class FaradayMiddleware::Avro::ParseAvro < FaradayMiddleware::ResponseMiddleware
  def process_response(env)
    env[:raw_body] = env[:body] if preserve_raw?(env)
    env[:body] = parse(env[:body], env[:response_headers]['Avro-Schema'])
  end

  def parse(body, schema_name)
    avro = AvroTurf.new(schemas_path: schemas_path)
    avro.decode(body, schema_name: schema_name) unless body.empty?
  end

  private

  def schemas_path
    @options[:schemas_path] || File.expand_path(File.dirname(__FILE__))
  end
end
